<?php

namespace Modules\Notice\Providers;

use Illuminate\Support\ServiceProvider;
use Illuminate\Support\Facades\Blade;
use Livewire\Livewire;

class ModuleServiceProvider extends ServiceProvider
{
    protected string $moduleName = 'Notice';

    public function register()
    {
        $this->app->register(RouteServiceProvider::class);
    }

    public function boot()
    {
        $this->registerViews();
        $this->registerLivewireViews();
        $this->registerMigrations();
        $this->registerConfig();
        $this->registerComponent();
        $this->registerLivewire();
    }

    protected function registerViews()
    {
        $moduleViewsPath = __DIR__ . '/../Views';
        $this->loadViewsFrom(
            $moduleViewsPath,
            strtolower($this->moduleName)
        );
    }

    protected function registerLivewireViews()
    {
        $moduleViewsPath = __DIR__ . '/../Views/livewire';
        $this->loadViewsFrom(
            $moduleViewsPath,
            strtolower($this->moduleName)
        );
    }

    protected function registerMigrations()
    {
        $this->loadMigrationsFrom(
            app_path('Modules/' . $this->moduleName . '/Database/Migrations')
        );
    }

    protected function registerConfig()
    {
        $path = app_path('Modules/' . $this->moduleName . '/Config/config.php');
        $this->mergeConfigFrom(
            $path,
            strtolower($this->moduleName)
        );

        $path = app_path('Modules/' . $this->moduleName . '/Config/notices.php');
        $this->mergeConfigFrom(
            $path,
            'notice.types'
        );
    }

    protected function registerLivewire()
    {
        Livewire::component('notices.user-notices', \Modules\Notice\Http\Livewire\UserNotices::class);
        Livewire::component('notices.user-notices-button', \Modules\Notice\Http\Livewire\UserNoticesButton::class);
    }

    protected function registerComponent()
    {
        //Blade::component('<name>', \Modules\<NAME>\Http\Components\<NAME>::class);
    }
}